<?php 

/* -----------------------------------------------------------------------------
  class name: manage_tables
  class version: 1.0
  date: 2007-10-31
  ------------------------------------------------------------------------------
  author: grum at grum.dnsalias.com
  << May the Little SpaceFrog be with you >>
  ------------------------------------------------------------------------------
  
  this class provides base functions to manage tables while plugin installation
    - constructor manage_tables($tables)
    - (public) function create_tables($tables_def)
    - (public) function update_tables_fields($tables_alteration)
    - (public) function drop_tables()

   ---------------------------------------------------------------------- */
class manage_tables
{
  var $tables;    //array of tables names

  function manage_tables($tables)
  {
    $this->tables = $tables;
  }
  
  /* 
      create tables
      $tables_def is an array of SQL CREATE queries

      return true if everything is ok, otherwise tablename 
  */
  function create_tables($tables_def)
  {
    //deleting tables if exists
    $this->drop_tables();

    for($i=0;$i<count($tables_def);$i++)
    {
      $result=pwg_query($tables_def[$i]);
      if(!$result)
      {
        //if an error occurs, deleting created tables
        $this->drop_tables();
        return(false);
      }
    }
    return(true);
  }

  /* update tables definition 
     $tables_alteration : array of arrays
      example :
      $tables_alteration['table1']=array(
        "attribute1" => " ADD COLUMN `attribute1` text null default ''",
        "attribute2" => " ADD COLUMN `attribute2` text null default ''"));
      $tables_alteration['table2']=array(
        "attribute1" => " ADD COLUMN `attribute1` text null default ''",
        "attribute2" => " ADD COLUMN `attribute2` text null default ''"));

      return true if no error, otherwise return table.fields of error 
  */
  function update_tables_fields($tables_alteration)
  {
    if(!is_array($tables_alteration))
    {
      return('');
    }

    reset($tables_alteration);
    while (list($key, $val) = each($tables_alteration))
    {
      $sql="SHOW COLUMNS FROM $key";
      $result=pwg_query($sql);
      if($result)
      {
        $columns=array();
        while($row=mysql_fetch_assoc($result))
        { 
          array_push($columns, $row['Field']); 
        }

        reset($val);
        while (list($attname, $sql) = each($val))
        {
          if(!in_array($attname, $columns))
          {
            $result=pwg_query("ALTER TABLE `$key` ".$sql);
            if(!$result)
            {
              return($key.".".$attname);
            }
          }
        }
      }
    }
    return(true);
  }


  /* 
      delete tables listed in $this->tables_list
  */
  function drop_tables()
  {
    foreach($this->tables as $key => $table_name)
    {
      $sql="DROP TABLE IF EXISTS ".$table_name;
      $result=pwg_query($sql);
    }
  }

} //class


?>