<?php
  include_once('plugin_class_root.inc.php');
  include_once('classes/tables.class.inc.php');

  /* mypolls class for install process */
  class install_mypolls extends root_mypolls 
  {
    var $tablef;

    function install_mypolls($prefixeTable, $filelocation)
    {
      parent::root_mypolls($prefixeTable, $filelocation);
      $this->tablef= new manage_tables($this->tables);
    }

    /* 
        function for installation process 
        return true if install process is ok, otherwise false 
    */ 
    function install()
    {
      $tables_def=array(
"CREATE TABLE `".$this->tables['polls']."` (
  `id` int(11) NOT NULL auto_increment,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `allowed_users` varchar(35) NOT NULL default 'guest/generic/normal/',
  `allowed_groups` varchar(250) NOT NULL default '',
  `visible` char(1) NOT NULL default 'n',
  `enabled` char(1) NOT NULL default 'n',
  `total_votes` int(11) NOT NULL default '0',
  `last_vote` datetime NOT NULL default '0000-00-00 00:00:00',
  `visit_without_vote` int(11) NOT NULL default '0',
  `visit_after_vote` int(11) NOT NULL default '0',
  `allow_comment` char(1) NOT NULL default 'n',
  `show_comments` char(1) NOT NULL default 'n',
  `color_bars` varchar(6) NOT NULL default '',
  `nb_questions` smallint(6) NOT NULL default '1',
  `display_type` enum('mono','multi') NOT NULL default 'mono',
  `default_lang` varchar(25) NOT NULL default '',
  `counter_questions` int(10) unsigned NOT NULL default '0',
  `nb_comments` int(11) NOT NULL default '0',
  `public_results` char(1) NOT NULL default 'y',
PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1",

"CREATE TABLE `".$this->tables['polls_lang']."` (
  `id_poll` int(11) NOT NULL default '0',
  `lang` varchar(25) NOT NULL default '',
  `title` varchar(250) NOT NULL default '',
  `description` text NOT NULL,
  `after_vote_text` text NOT NULL,
  PRIMARY KEY  (`id_poll`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1",

"CREATE TABLE `".$this->tables['polls_questions']."` (
  `id_poll` int(11) NOT NULL default '0',
  `question_num` int(11) NOT NULL default '1',
  `question_type` enum('mono','multi','order') NOT NULL default 'mono',
  `multi_max_answers` smallint(6) NOT NULL default '2',
  `counter_answers` int(10) unsigned NOT NULL default '0',
  `nb_votes` int(11) NOT NULL default '0',
PRIMARY KEY  (`id_poll`,`question_num`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1",

"CREATE TABLE `".$this->tables['polls_questions_lang']."` (
  `id_poll` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `lang` varchar(25) NOT NULL default '',
  `description` text NOT NULL,
  PRIMARY KEY  (`id_poll`,`id_question`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1",

"CREATE TABLE `".$this->tables['polls_answers']."` (
  `id_poll` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `answer_num` int(11) NOT NULL default '0',
  `nb_votes` int(11) NOT NULL default '0',
  `frequency` int(11) NOT NULL default '0',
  `ans_order` smallint(6) NOT NULL default '0',
PRIMARY KEY  (`id_poll`,`id_question`,`answer_num`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1",

"CREATE TABLE `".$this->tables['polls_answers_lang']."` (
  `id_poll` int(11) NOT NULL default '0',
  `id_question` int(11) NOT NULL default '0',
  `id_answer` int(11) NOT NULL default '0',
  `lang` varchar(25) NOT NULL default '',
  `answer` varchar(250) NOT NULL default '',
  `nb_votes` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id_poll`,`id_question`,`id_answer`,`lang`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1",

"CREATE TABLE `".$this->tables['polls_votes']."` (
  `poll_id` INTEGER  NOT NULL DEFAULT '0',
  `user_id` VARCHAR(15)  NOT NULL DEFAULT '2',
  `date` DATETIME  NOT NULL DEFAULT '0000-00-00 00:00:00',
  `user_comment` TEXT  NOT NULL,
  PRIMARY KEY(`poll_id`, `user_id`)
) ENGINE = MYISAM DEFAULT CHARSET=latin1"
      );
      //$table_def array

      $result=$this->tablef->create_tables($tables_def);
      if($result)
      {
        $result=$this->add_enum_to_history();
      }

      return($result);
    }


    /*
        function for uninstall process
    */
    function uninstall()
    {
      $this->delete_config();
      $this->tablef->drop_tables();
    }

    function activate()
    {
      $this->tablef->update_tables_fields(false);
      $this->init_config();
      $this->load_config();
      $this->save_config();
    }

    function deactivate()
    {
    }


    /* specific function to obtain field 'section' enumeration */
    function get_section_enum($add)
    {
      $sql = 'SHOW COLUMNS FROM '.HISTORY_TABLE.' LIKE "section"';
      $result=pwg_query($sql);
      if($result)
      {
        $row = mysql_fetch_array($result);
        $list=substr($row['Type'], 5, strlen($row['Type'])-6);
        $returned=explode(',', $list);
        if((strpos($list, "'$add'")===false)&&($add!='')) 
        { 
          array_push($returned, "'$add'"); 
        }
        return($returned);
      }
    }

    function add_enum_to_history()
    {
      $enums=implode(',', $this->get_section_enum($this->section_name));
      $sql="ALTER TABLE ".HISTORY_TABLE."
             CHANGE `section` `section` 
             ENUM (".$enums.") ;";
      $result=pwg_query($sql);
      return($result);
    }


  }

?>
